--
--      gcd main process
--

PACKAGE gcd8_pack IS
  CONSTANT SIZE : INTEGER := 3;
END gcd8_pack;

LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.std_logic_arith.ALL;
--USE WORK.NUMERIC_BIT.ALL;

USE WORK.gcd8_pack.ALL;

entity gcd8 is
	port (	clock, reset : in bit;
			xi,yi : in  UNSIGNED (SIZE-1 DOWNTO 0);
			ou    : out UNSIGNED (SIZE-1 DOWNTO 0)
	) ;
end gcd8;

architecture gcd8 of gcd8 is
begin
	process
		variable x, y,temp : UNSIGNED (SIZE-1 DOWNTO 0);
	begin
		wait until clock = '1';
		x := xi;
		y := yi;
		--while (x > 0) loop
		for i in 0 to 7 loop
		     if ( x /= y ) then
			if (x <= y) then
				temp:=y;
				y := x;
				x:=temp;
			end if;
			x := x - y;
		     else
		        ou <= y;
		     end if;
    		end loop;
    		ou <= y;
	end process;
end gcd8;

